package assignment10.Database;

public class MyBarrier {

  private int i = 0;
  private final int n;
  private boolean draining = false;

  MyBarrier(int n) {
    this.n = n; 
  }

  synchronized void await() throws InterruptedException {
    while (draining) {
      wait();
    }
    ++i;
    while (i < n && !draining) {
      wait(); 
    }
    if (i-- == n) {
      draining = true;
      notifyAll();
    }
    if (i == 0) {
      draining = false;
      notifyAll();
    }
  }

}
